/*
 * $Id: Shell.java,v 1.4 2004/12/23 15:53:20 rampil Exp $
 * Copyright (c) 2004 LOGICAL-PARADOX.ORG
 */
package org.logical_paradox.shell;

import java.io.OutputStream;
import java.util.ResourceBundle;

import org.logical_paradox.shell.exception.*;
import org.logical_paradox.shell.exception.TerminationException;

/**
 * ۃVFNX
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.4 $
 */
public abstract class Shell {
	private CommandLineParser parser;
	private ShellEnv env;

	/**
	 * RXgN^
	 * @throws Exception CX^X̏ɔO
	 */
	public Shell() throws Exception {
		setup();
	}
	/**
	 * CX^X̏
	 * @throws Exception Ɏsꍇ̗O
	 */
	protected void setup() throws Exception {
		// VF\[X̃[h
		ResourceBundle rb = ResourceBundle.getBundle("shell");
		// VFϐ̍쐬
		env = new ShellEnv(rb);
		parser = createCommandLineParser(env);
	}
	/**
	 * R}hCp[U[𐶐
	 * ̃\bh͋ۃNXŎ
	 * @param se VFϐ
	 * @return ꂽp[U[
	 * @throws Exception p[U[̐ɎsꍇɔO
	 */
	protected abstract CommandLineParser createCommandLineParser(ShellEnv se) throws Exception;

	/**
	 * ϐNXԂ
	 * @return ϐNX
	 */
	public ShellEnv getEnv() {
		return env;
	}
	/**
	 * ʏɎs郁\bh
	 * @param ostream o̓Xg[
	 */
	public void onInitDisplay(OutputStream ostream) {
	}
	/**
	 * R}hss
	 * @param ostream o̓Xg[
	 * @param script R}hs̓e
	 * @return ʃXe[^X
	 * @throws CommandExecutionException R}h̎sɔO
	 * @throws ParserException R}hs̉͂ɎsꍇɔO
	 * @throws TerminationException IVOiMꂽꍇ̗O
	 */
	public int execute(OutputStream ostream, String script) throws CommandExecutionException, ParserException, TerminationException {
		// O
		int rc = preExecution(ostream, script);
		if(rc != ResultCode.STATUS_OK) {
			return rc;
		}
		try {
			CommandLineParameters param = parser.parse(script);
			ResultCode exitCode = param.getCommand().execute(ostream, env, param.getArgument());
			return exitCode.getStatus();
		} finally {
			// ㏈
			int postResultCode = postExecution(ostream, script);
			if(postResultCode != ResultCode.STATUS_OK) {
				return postResultCode;
			}
		}
	}
	/**
	 * R}hssOɌĂяo鏈
	 * R}hsOɉꍇÃ\bhI[o[ChĎ
	 * @param ostream o̓Xg[
	 * @param script R}hs̓e
	 * @return ʃXe[^X
	 * @throws CommandExecutionException R}h̎sɔO
	 * @throws TerminationException IVOiMꂽꍇ̗O
	 */
	protected int preExecution(OutputStream ostream, String script) throws CommandExecutionException, TerminationException {
		return ResultCode.STATUS_OK;
	}
	/**
	 * R}hssɌĂяo鏈
	 * R}hsɉꍇÃ\bhI[o[ChĎ
	 * @param ostream o̓Xg[
	 * @param script R}hs̓e
	 * @return ʃXe[^X
	 * @throws CommandExecutionException R}h̎sɔO
	 * @throws TerminationException IVOiMꂽꍇ̗O
	 */
	protected int postExecution(OutputStream ostream, String script) throws CommandExecutionException, TerminationException {
		return ResultCode.STATUS_OK;
	}
}
